/**************************************************************************//**
 * @file etm_trace_problems.c
 * @brief ETM trace debugging code example
 * @author Energy Micro AS
 * @version 1.02
 ******************************************************************************
 * @section License
 * <b>(C) Copyright 2013 Energy Micro AS, http://www.energymicro.com</b>
 *******************************************************************************
 *
 * Permission is granted to anyone to use this software for any purpose,
 * including commercial applications, and to alter it and redistribute it
 * freely, subject to the following restrictions:
 *
 * 1. The origin of this software must not be misrepresented; you must not
 *    claim that you wrote the original software.
 * 2. Altered source versions must be plainly marked as such, and must not be
 *    misrepresented as being the original software.
 * 3. This notice may not be removed or altered from any source distribution.
 * 4. The source and compiled code may only be used on Energy Micro "EFM32"
 *    microcontrollers and "EFR4" radios.
 *
 * DISCLAIMER OF WARRANTY/LIMITATION OF REMEDIES: Energy Micro AS has no
 * obligation to support this Software. Energy Micro AS is providing the
 * Software "AS IS", with no express or implied warranties of any kind,
 * including, but not limited to, any implied warranties of merchantability
 * or fitness for any particular purpose or warranties against infringement
 * of any proprietary rights of a third party.
 *
 * Energy Micro AS will not be liable for any consequential, incidental, or
 * special damages, or any other relief, or for any claim by any third party,
 * arising from your use of this Software.
 *
 *****************************************************************************/

#include "em_device.h"
#include "bsp_trace.h"

/* Remove this define to enable the stack overflow problem. */
#define ILLEGAL_ADDRESS

void foo(volatile int* p_number)
{
  #ifdef ILLEGAL_ADDRESS
  *p_number-- = 1;
  #endif
 
  foo(p_number);
}

/**************************************************************************//**
 * @brief  Main function
 *****************************************************************************/
int main(void)
{ 
  
  BSP_TraceEtmSetup();
  
  volatile int testPoint;
  
  static volatile int* testAddress = (volatile int*) (0x80000010);
  

  while(1){
    /* Trace trigger 1 */
    testPoint = 0;    
    
    foo(testAddress);
    
    /* Trace trigger 2 */
    testPoint;    
  }
}
